\\ Copyright 2021 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0);
default(strictargs,1);


\\-----------------------------------------------------------------------------

\\ A061775
num_vertices(primecode) =
{
  my(f=factor(primecode));
  1 + [num_vertices(primepi(p)) |p<-f[,1]] * f[,2];
}
{
  print1("num vertices: ");
  for(primecode=1,20,
     print1(num_vertices(primecode),","));
  print("...  (A061775)");
}

is_unicentroidal_root(primecode) =
{
  my(f=factor(primecode),
     subtrees=[num_vertices(primepi(p)) |p<-f[,1]],
     total=1+subtrees*f[,2]);
  #subtrees==0 || 2*vecmax(subtrees) < total;
}

{
  print1("unicentroidal roots: ");
  for(primecode=1,36,
     if(is_unicentroidal_root(primecode),
        print1(primecode,",")));
  print("...  (A999999)");
}  

print("end");
