\\ Copyright 2017, 2018, 2019, 2020, 2021 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0)
default(strictargs,1)
default(parisizemax,300*10^6);
read("../vpar.gp");
read("../vpar-wip.gp");
read("../test-helpers.gp");
read("memoize.gp");
\\ GP-DEFINE  read("../vpar.gp");
\\ GP-DEFINE  read("../vpar-wip.gp");

option_verbose=0;
progress_prev=-1;
progress(str) =
{
  my(t=getwalltime()\2000);
  if(t!=progress_prev,
     progress_prev=t;
     print(str));
}


\\------------------------------------------------------------------------------
\\ isomorphic halves

\\ *---*---*---*---B --- A---*---*---*---*
\\         |   |   |         |   |
\\         *   A   *         B   *
\\                           |
\\                           *

\\ *---A---*---*---*---*       \
\\         |   |               | half
\\         B   *               /
\\         |                   
\\     *---C---*---*---*---*   \
\\             |   |           | half
\\             D   *           /

vpar=[0, 1, 2, 3, 4, 5, 4, 3, 2, 1, 10, 11, 12, 11, 10, 15]
vpar_diameter(vpar)
c=vpar_centres(vpar)
vpar=test_delete_edge(vpar,c[1],c[2])
vpars=vpar_component_trees(vpar)
vpar_eccentricity_of_vertex(vpars[1],1)
vpar_eccentricity_of_vertex(vpars[2],1)

{
  for(n=16,16,
     my(vpar=vpar_free_first(n),
        count_same=0,
        count_any=0);
     until((vpar=vpar_free_next(vpar))=='none,
           my(is_any=test_is_isomorphic_halves(vpar));
           if(is_any, count_any++);

           my(is_same=test_is_isomorphic_halves(vpar,1));
           if(is_same, count_same++);

           if(is_any && ! is_same,
              print(vpar));
          );
     print(count_same" "count_any);
     );
  quit;
}


\\------------------------------------------------------------------------------
