\\ Copyright 2017, 2018 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0)
default(strictargs,1)
read("../vpar.gp");
read("../vpar-wip.gp");
read("../test-helpers.gp");
read("memoize.gp");

option_verbose = 1;


\\------------------------------------------------------------------------------

vpar_preorder_ith(8,1,1)
vpar_preorder_ith(8,1,0)
quit

\\------------------------------------------------------------------------------

CT(n,k) = binomial(n+k,n)*(n-k+1)/(n+1);

ith_depths(n,i) =
{
  \\ print("ith_depths() n="n"  i="i);
  if(i<1, return('none));
  my(vpar=vector(n),
     depth=0,   \\ depth of parent vertex
     p=1);      \\ parent vertex
  for(v=2,n,
     forstep(d=depth+1, 1, -1, 
            \\ my(c=CT(n-v+d, n-v));
            my(r=n-v);
            my(c=binomial((r<<1)+d, r+d) * (d+1) / (r+d+1));
            if(i>c, i-=c; p=vpar[p],
                    vpar[v]=p; p=v; depth=d; next(2)));
  );
  if(i>1, 'none, vpar);
}
\\ith_depths(0,1)
\\ ith_depths(5,2)
\\ ith_depths(5,3)

ret=ith_depths(8,8)
print("ret "ret);

print("iterate");
vpar=vpar_preorder_first(8)
{
  for(i=1,7, 
     vpar=vpar_preorder_next(vpar);
     my(depths=vpar_depths_vector(vpar));
     print(vpar"  depths "depths);
  );
}

print();
{
  my(n=8, i=1);
  my(vpar=vpar_preorder_first(n));
  until((vpar=vpar_preorder_next(vpar))=='none,
        my(depths=vpar_depths_vector(vpar));
        my(got_vpar=ith_depths(n,i),
           diff=if(got_vpar==vpar, "", " diff"));
        if(got_vpar!=vpar,error());
        
        print("i="i"  "vpar"  "got_vpar,diff);
        i++;
       );
}
quit


\\------------------------------------------------------------------------------

CT(n,k) = binomial(n+k,n)*(n-k+1)/(n+1);
{
  print1("   "); for(k=0,8, printf("%4d, ",k)); print();
  for(n=1,8, 
     print1("n="n); for(k=0,n, printf("%4d, ",CT(n,k))); print());
}

ith_depths(n,i) =
{
  \\ print("ith_depths() n="n"  i="i);
  if(i<1, return('none));
  my(depths=vector(n,i, i!=1),
     vpar=vector(n));
  for(p=2,n,
     my(d_hi=depths[p-1]+1,
        v=p-1);
     \\ print(" p="p" n="n-p+1" range d= "d_hi" to 1");
     forstep(d=d_hi, 1, -1, 
            my(k=n-p,
               n=k+d,
               c=CT(n,k));
            \\ print("  d="d" k="k"  i="i" CT("n","k") = "c);
            if(i>c,
               i-=c; v=vpar[v];
               ,
               \\ print("   set depths["p"] = "d"  vpar["p"]="v);
               depths[p]=d;
               vpar[p]=v;
               next(2)));
  );
  \\ print(" final i="i);
  if(i>1, 'none, vpar);
}
\\ith_depths(0,1)
\\ ith_depths(5,2)
\\ ith_depths(5,3)

ret=ith_depths(8,8)
print("ret "ret);

print("iterate");
vpar=vpar_preorder_first(8)
{
  for(i=1,7, 
     vpar=vpar_preorder_next(vpar);
     my(depths=vpar_depths_vector(vpar));
     print(vpar"  depths "depths);
  );
}

print();
{
  my(n=8, i=1);
  my(vpar=vpar_preorder_first(n));
  until((vpar=vpar_preorder_next(vpar))=='none,
        my(depths=vpar_depths_vector(vpar));
        my(got_vpar=ith_depths(n,i),
           diff=if(got_vpar==vpar, "", " diff"));
        
        print("i="i"  "vpar"  "got_vpar,diff);
        i++;
       );
}
quit


\\------------------------------------------------------------------------------
\\ preorder number of possible depths after

\\ A078391 Catalan triangle T(n,k) = Catalan(k)*Catalan(n-k).
\\ A009766 Catalan triangle by rows
\\         a(n,k) = binomial(n+k, n)*(n-k+1)/(n+1), 0 <= k <= n.
\\

check_equal(132+297, 429);
check_equal(84+180+165, 429);

n=8;
m=matrix(n+1,n+1);
{
  print(vpar_count_ordered(n));
  my(vpar=vpar_preorder_first(n));
  until((vpar=vpar_preorder_next(vpar))=='none,
        my(depths=vpar_depths_vector(vpar));
        for(i=1,#depths,
           m[depths[i]+1,i]++);
       );
}
m
m[2,]
quit;

{
  my(n=8,
     m=matrix(n+1,n+1));
  print(vpar_count_ordered(n-1));
  my(depths=vpar_preorder_depths_first(n));
  until((depths=vpar_preorder_depths_next(depths))=='none,

        for(i=1,#depths,
           m[i,depths[i]+1]++);
       );
  m
}
quit;


\\------------------------------------------------------------------------------
\\ A009766 Catalan triangle
\\ a(n,m) = binomial(n+m,n)*(n-m+1)/(n+1), 0 <= m <= n.

m=matrix(10+1,10+1);
{
for(z=1,10,
   t = m[z+1,0+1] = 1;
   for(n=1,z,
      t += m[z-1+1,n+1];
      m[z+1,n+1] = t;
      ));
}
m
m[11,]
quit

\\ for z=1 upwards
\\   numvalues(z,0) = 1
\\   for n = 1 to z
\\     numvalues(z,n) = numvalues(z-1,n)  # the 0... forms
\\                    + numvalues(z,n-1)  # the 1... forms

N(z,n) =
{
  if(n==0, 1,
     z==0, 1,
     N(z-1,n) + N(z,n-1));
}
for(n=0,6, for(z=1,10, print1(N(z,n)", ")); print());
quit;

\\ [0  0  0   0   0    0    0    0     0     0     0]
\\ [1  1  0   0   0    0    0    0     0     0     0]
\\ [1  2  2   0   0    0    0    0     0     0     0]
\\ [1  3  5   5   0    0    0    0     0     0     0]
\\ [1  4  9  14  14    0    0    0     0     0     0]
\\ [1  5 14  28  42   42    0    0     0     0     0]
\\ [1  6 20  48  90  132  132    0     0     0     0]
\\ [1  7 27  75 165  297  429  429     0     0     0]
