\\ Copyright 2018, 2019, 2020 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0)
default(strictargs,1)
read("../vpar.gp");


\\ Usage: gp <reroot-path.gp
\\
\\ After re-rooting, at each vertex the neighbours are unchanged.
\\ Just edge directions changed to go towards 3 instead of towards 1.

n = 4;
vpar = vpar_make_path(n);

\\       1     root
\\       |
\\       2
\\       |
\\       3
\\       |
\\       4
\\
print("path-"n" is vpar="vpar);

\\       3    root
\\      / \
\\     2   4
\\    /
\\   1
\\  
vpar = vpar_reroot(vpar,3);
print("reroot to 3 gives vpar="vpar);

