# Copyright 2017, 2018, 2019, 2020 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  See the file COPYING.  If not, see
# <http://www.gnu.org/licenses/>.


if (! eval { require MyGraphs; }) {
  print "MyGraphs not available\n";
} else {
  # ../examples/most-maximum-matchings.gp
  require IPC::Run;
  my $filename = File::Spec->catfile($examples_dir,'most-maximum-matchings.gp');
  my $str = File::Slurp::read_file($filename);
  $str =~ /House of Graphs(.*?)--------------------------------------/s
    or die;
  my %n_to_id;
  while ($str =~ /^\\\\\s*(\d+)\s+n=([0-9.]+)/mg) {
    $n_to_id{$2} = $1;
  }
  ### %n_to_id
  print "$filename ",scalar(keys %n_to_id)," HOG\n";

  my $make_str = '';
  my @n_list = (1..200, 6.5, 34.5);
  foreach my $n (@n_list) {
    $make_str .= "print(\">>graph6<<\",vpar_to_graph6(make($n)));\n";
  }
  IPC::Run::run(['gp',$filename],
                '<', \$make_str,
                '>', \my $out,
                '2>', File::Spec->devnull);
  while ($out =~ /^>>graph6<<(.*)/mg) {
    my $graph6 = $1;
    $graph6 = MyGraphs::graph6_str_to_canonical($graph6);
    # print "$graph6\n";
    my $id = MyGraphs::hog_grep($graph6) || 'none';
    my $n = shift @n_list;
    my $want_id = $n_to_id{$n} // 'none';
    unless (defined $id == defined $want_id
            && (! defined $want_id || $id eq $want_id)) {
      bad("$filename:1: wrong HOG, n=$n got $id want $want_id\n");
    }
  }
}

